#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import sys


class PotfileWriter:
	def __init__(self, potfile):
		self.out = open(potfile, 'w')
		self.out.write('# List of source files containing translatable strings.\n')
		self.out.write('# AUTOGENERATED FILE by update_potfiles_in.py\n')
		self.out.write('# DO NOT EDIT THIS FILE\n\n')
		self.out.write('[encoding: UTF-8]\n')

	def close(self):
		self.out.close();

	def scandir(self, path, subpath, extension, prefix):
		searchdir = os.path.join(path, subpath)
		extelne = len(extension)
		for file in os.listdir(searchdir):
			if(file[0:1] == '.'):
				continue
			
			currentPath = os.path.join(searchdir, file)
				
			if os.path.isfile(currentPath):
				if(file[-extelne:] == extension):
#					print 'file: %s' % currentPath
					self.out.write(os.path.join(prefix, subpath, file) + '\n')
			else:
				self.scandir(path, os.path.join(subpath, file), extension, prefix)
#				print 'folder: %s' % currentPath


rootdir = os.path.realpath(__file__ + '/../../')

writer = PotfileWriter(os.path.realpath(__file__ + '/../POTFILES.in'))

print "Scanning folder ui: %s" % rootdir + '/ui'
writer.scandir(rootdir, 'ui', '.glade', '[type: gettext/glade]');

print "Scanning folder src: %s" % rootdir + '/src'
writer.scandir(rootdir, 'src', '.cpp', '');


writer.close()

print 'finished'

